#include "SoundManager.h"
#include <iostream>
SoundManager * SoundManager::Singleton = new SoundManager();

bool 
SoundQueue::Advance()
{
	offset++;
	if (offset < samples.size())
	{
		channel = SoundManager::Singleton->Play(*samples[offset],0);
		return true;
	}
	else
		return false;
}

void 
SoundManager::finishCallback(int chan)
{
	for (vector<SoundQueue>::iterator i = Singleton->queues.begin(); i < Singleton->queues.end(); i++)
	{
		if (chan == i->channel)
		{
			if (!i->Advance())
				Singleton->queues.erase(i);
			break;

		}
	}
	//cout << Singleton->queues.size() << endl;
}

SoundManager::SoundManager() : active(false)
{
}

SoundManager::~SoundManager()
{
	Deactivate();
}

bool
SoundManager::Activate()
{
	if(Mix_OpenAudio(22050,MIX_DEFAULT_FORMAT,2,1024)<0)
	{
		Mix_CloseAudio();
		return false;
	}
	Mix_ChannelFinished(SoundManager::finishCallback);
	active = true;

}
void 
SoundManager::PauseAll(bool val)
{
	if (val)
		Mix_Pause(-1);
	else
		Mix_Resume(-1);
}


void
SoundManager::Deactivate()
{
	if (active)
	{
		Mix_CloseAudio();
	}
}

void 
SoundManager::SetNumChannels(unsigned int channels)
{
	if (active)
		Mix_AllocateChannels(channels);
}

int 
SoundManager::Play(AudioSample & s,int loops)
{
	if (active)
		return Mix_PlayChannel(-1,s.data,loops);
	return -1;
}

void 
SoundManager::PlayQueue(vector<AudioSample*> & samps)
{
	if (samps.size() == 0)
		return;
	if (active)
	{
		SoundQueue q;
		q.samples = samps;
		q.channel = SoundManager::Singleton->Play(*samps[0],0);
		if (q.channel != -1)
			queues.push_back(q);
	}

}
