#ifndef SpellShot_h
#define SpellShot_h

#include "enum.h"
#include "SpellPoints.h"
#include "Sprite.h"
#include "particle.h"

class SpellShot
{
public:
	SpellShot(float x, float y, float vx, float vy, const Frame* f, ParticleEmitter* e, eSpellSources t, const SpellPoints& pts);
	~SpellShot();
	void Draw();
	void Update(double timeDif);

	void Manipulate(float x, float y, float timeDif);
	

	void ResetEmitter(ParticleEmitter* e);

	float pos[2];
	float vel[2];

	SpellPoints points;
	eSpellSources type;
	const Frame* frame;

	int calcDamage();

	float life;

	float size;

private:

	float accel[2];

	float accelMag;

	ParticleEmitter* emitter;
};

extern SpellShot* shot;
extern FrameSet magicFrames;
extern const Frame* genericShotFrame;
extern const Frame* shotFrame[eNumSpellSources];
extern ParticleEmitter* shotEmitter[eNumSpellSources];


#endif
