#ifndef __WIZARD_H__
#define __WIZARD_H__

#include "entity.h"
#include "spellPoints.h"


class Wizard : public Entity
{
public:

	Wizard(float x, float y);
	virtual ~Wizard();

	float getHps() const;
	void  setHps(float h);
	float incHps(float dhps);
	float decHps(float dhps);

	bool isDead() const;

	float getMana() const;
	void  setMana(float m);
	float incMana(float dmana);
	float decMana(float dmana);

	bool hasMana() const;

	void getMoveTo(float& x, float& y) const;
	void setMoveTo(float  x, float  y);

	void getDir(float& x, float& y) const;

	bool isWalking() const;
	bool hasWalked() const;
	void setHasWalked();
	void resetHasWalked();

	SpellPoints& getSpellPts() { return spellPts; }

	virtual void update(double dt);

private:

	float hps;
	float mana;

	float moveTo[2];
	float dir[2];
	float speed;

	bool  hasMoved;

	SpellPoints spellPts;
};

#endif // __WIZARD_H__